<?php

namespace App\Admin\Controllers;

use OpenAdmin\Admin\Controllers\AdminController;
use OpenAdmin\Admin\Form;
use OpenAdmin\Admin\Grid;
use OpenAdmin\Admin\Show;
use \App\Models\Contracts;

class ContractsController extends AdminController
{
    /**
     * Title for current resource.
     *
     * @var string
     */
    protected $title = 'Contracts';

    /**
     * Make a grid builder.
     *
     * @return Grid
     */
    protected function grid()
    {
        $grid = new Grid(new Contracts());

        $grid->column('id', __('Id'));
        $grid->column('client', __('Client'));
        $grid->column('contract_date', __('Contract date'));
        $grid->column('expiry_date', __('Expiry date'));
        $grid->column('year', __('Year'));
        $grid->column('status', __('Status'));
        $grid->column('documents', __('Documents'));
        $grid->column('created_at', __('Created at'));
        $grid->column('updated_at', __('Updated at'));

        return $grid;
    }

    /**
     * Make a show builder.
     *
     * @param mixed $id
     * @return Show
     */
    protected function detail($id)
    {
        $show = new Show(Contracts::findOrFail($id));

        $show->field('id', __('Id'));
        $show->field('client', __('Client'));
        $show->field('contract_date', __('Contract date'));
        $show->field('expiry_date', __('Expiry date'));
        $show->field('year', __('Year'));
        $show->field('status', __('Status'));
        $show->field('documents', __('Documents'));
        $show->field('created_at', __('Created at'));
        $show->field('updated_at', __('Updated at'));

        return $show;
    }

    /**
     * Make a form builder.
     *
     * @return Form
     */
    protected function form()
    {
        $form = new Form(new Contracts());

        $form->text('client', __('Client'));
        $form->text('contract_date', __('Contract date'));
        $form->text('expiry_date', __('Expiry date'));
        $form->text('year', __('Year'));
        $form->text('status', __('Status'));
        $form->text('documents', __('Documents'));

        return $form;
    }
}
