<?php

namespace App\Admin\Controllers;

use OpenAdmin\Admin\Controllers\AdminController;
use OpenAdmin\Admin\Form;
use OpenAdmin\Admin\Grid;
use OpenAdmin\Admin\Show;
use \App\Models\Provisions;

class ProvisionsController extends AdminController
{
    /**
     * Title for current resource.
     *
     * @var string
     */
    protected $title = 'Provisions';

    /**
     * Make a grid builder.
     *
     * @return Grid
     */
    protected function grid()
    {
        $grid = new Grid(new Provisions());

        $grid->column('id', __('Id'));
        $grid->column('client', __('Client'));
        $grid->column('type', __('Type'));
        $grid->column('provision', __('Provision'));
        $grid->column('quantity', __('Quantity'));
        $grid->column('cost', __('Cost'));
        $grid->column('created_by', __('Created by'));
        $grid->column('updated_by', __('Updated by'));
        $grid->column('created_at', __('Created at'));
        $grid->column('updated_at', __('Updated at'));

        return $grid;
    }

    /**
     * Make a show builder.
     *
     * @param mixed $id
     * @return Show
     */
    protected function detail($id)
    {
        $show = new Show(Provisions::findOrFail($id));

        $show->field('id', __('Id'));
        $show->field('client', __('Client'));
        $show->field('type', __('Type'));
        $show->field('provision', __('Provision'));
        $show->field('quantity', __('Quantity'));
        $show->field('cost', __('Cost'));
        $show->field('created_by', __('Created by'));
        $show->field('updated_by', __('Updated by'));
        $show->field('created_at', __('Created at'));
        $show->field('updated_at', __('Updated at'));

        return $show;
    }

    /**
     * Make a form builder.
     *
     * @return Form
     */
    protected function form()
    {
        $form = new Form(new Provisions());

        $form->text('client', __('Client'));
        $form->text('type', __('Type'));
        $form->text('provision', __('Provision'));
        $form->decimal('quantity', __('Quantity'));
        $form->decimal('cost', __('Cost'));
        $form->text('created_by', __('Created by'));
        $form->text('updated_by', __('Updated by'));

        return $form;
    }
}
