<?php

namespace App\Admin\Controllers;

use OpenAdmin\Admin\Controllers\AdminController;
use OpenAdmin\Admin\Form;
use OpenAdmin\Admin\Grid;
use OpenAdmin\Admin\Show;
use \App\Models\SubZones;
use \App\Models\Zones;

class SubZonesController extends AdminController
{
    /**
     * Title for current resource.
     *
     * @var string
     */
    protected $title = 'SubZones';

    /**
     * Make a grid builder.
     *
     * @return Grid
     */
    protected function grid()
    {
        $grid = new Grid(new SubZones());

        $grid->column('id', __('Id'));
        $grid->column('name', __('Name'));
        // $grid->column('zone', __('Zone'));
        $grid->column('zones.name',__('Zone'));
        $grid->column('initial',__('Initial'));
        // $grid->column('profile.gender');
        // $grid->column('created_at', __('Created at'));
        // $grid->column('updated_at', __('Updated at'));

        return $grid;
    }

    /**
     * Make a show builder.
     *
     * @param mixed $id
     * @return Show
     */
    protected function detail($id)
    {
        $show = new Show(SubZones::findOrFail($id));

        $show->field('id', __('Id'));
        $show->field('name', __('Name'));
        $show->field('zone', __('Zone'));
        $show->field('created_at', __('Created at'));
        $show->field('updated_at', __('Updated at'));

        return $show;
    }

    /**
     * Make a form builder.
     *
     * @return Form
     */
    protected function form()
    {
        $form = new Form(new SubZones());
        $form->text('name', __('Name'))->required();
        $form->select('zone', __("Zone"))->options(Zones::all()->pluck('name', 'id'))->required();
        $form->text('initial', __('Initial'))->required();
        return $form;
    }
}