<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('clients', function (Blueprint $table) {
            $table->id();
            $table->string('first_name')->nullable();
            $table->string('last_name')->nullable();
            $table->string('phone')->nullable();
            $table->string('email')->nullable();
            $table->string('id_number')->nullable();
            $table->string('zone_id')->nullable();
            $table->string('sub_zone')->nullable();
            $table->string('contract_date')->nullable();
            $table->string('contract_expiry')->nullable();
            $table->string('photo')->nullable();
            $table->text('address')->nullable();
            $table->string('status')->nullable()->default(1);
            $table->string('county')->nullable();
            $table->string('sub_county')->nullable();
            $table->string('location')->nullable();
            $table->string('gender')->nullable();
            $table->string('created_by')->nullable();
            $table->string('updated_by')->nullable();
            
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('clients');
    }
};